Module java.compiler
Package javax.lang.model.util

## Class TypeKindVisitor7<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractTypeVisitor6<R,P>
  - - javax.lang.model.util.SimpleTypeVisitor6<R,P>
    - - javax.lang.model.util.TypeKindVisitor6<R,P>
      - - javax.lang.model.util.TypeKindVisitor7<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  TypeVisitor<R,P>

Direct Known Subclasses:
  TypeKindVisitor8

    @SupportedSourceVersion(RELEASE_7)
    public class TypeKindVisitor7<R,P>
    extends TypeKindVisitor6<R,P>

A visitor of types based on their kind with default behavior appropriate for the `RELEASE_7` source version. For types `XYZ` that may have more than one kind, the `visitXYZ` methods in this class delegate to the `visitXYZKind` method corresponding to the first argument's kind. The `visitXYZKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

Methods in this class may be overridden subject to their general contract. Note that annotating methods in concrete subclasses with `@Override` will help ensure that methods are overridden as intended.

WARNING: The `TypeVisitor` interface implemented by this class may have methods added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new type kind visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

Note that adding a default implementation of a new visit method in a visitor class will occur instead of adding a default method directly in the visitor interface since a Java SE 8 language feature cannot be used to this version of the API since this version is required to be runnable on Java SE 7 implementations. Future versions of the API that are only required to run on Java SE 8 and later may take advantage of default methods in this situation.

Since:
  1.7
See Also:
  `TypeKindVisitor6`, `TypeKindVisitor8`

### Field Summary

### Fields inherited from class javax.lang.model.util.SimpleTypeVisitor6

`DEFAULT_VALUE`

### Constructor Summary

Constructors
`protected` `TypeKindVisitor7()` Constructor for concrete subclasses to call; uses `null` for the default value.
`protected` `TypeKindVisitor7(R defaultValue)` Constructor for concrete subclasses to call; uses the argument for the default value.

### Method Summary

All Methods Instance Methods Concrete Methods
`R` `visitUnion(UnionType t, P p)` This implementation visits a `UnionType` by calling `defaultAction`.

### Methods inherited from class javax.lang.model.util.AbstractTypeVisitor6

`visit, visit, visitIntersection, visitUnknown`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from class javax.lang.model.util.SimpleTypeVisitor6

`defaultAction, visitArray, visitDeclared, visitError, visitExecutable, visitNull, visitTypeVariable, visitWildcard`

### Methods inherited from class javax.lang.model.util.TypeKindVisitor6

`visitNoType, visitNoTypeAsNone, visitNoTypeAsPackage, visitNoTypeAsVoid, visitPrimitive, visitPrimitiveAsBoolean, visitPrimitiveAsByte, visitPrimitiveAsChar, visitPrimitiveAsDouble, visitPrimitiveAsFloat, visitPrimitiveAsInt, visitPrimitiveAsLong, visitPrimitiveAsShort`

### Constructor Detail

#### TypeKindVisitor7

    protected TypeKindVisitor7()

Constructor for concrete subclasses to call; uses `null` for the default value.

#### TypeKindVisitor7

    protected TypeKindVisitor7(R defaultValue)

Constructor for concrete subclasses to call; uses the argument for the default value.

Parameters:
  `defaultValue` - the value to assign to `SimpleTypeVisitor6.DEFAULT_VALUE`

### Method Detail

#### visitUnion

    public R visitUnion(UnionType t,
                        P p)

This implementation visits a `UnionType` by calling `defaultAction`.

Specified by:
  `visitUnion` in interface `TypeVisitor<R,P>`
Overrides:
  `visitUnion` in class `AbstractTypeVisitor6<R,P>`
Parameters:
  `t` - the type to visit
  `p` - a visitor-specified parameter
Returns:
  the result of `defaultAction`